"""
/***************************************************************************
CARICA CXF 
                                 A QGIS plugin

                             -------------------
        begin                : 2012-09-13
        copyright            : (C) 2012 by Arch. Fabio SAccon
        email                : saccon@gisplan.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""
from PyQt4.QtGui import *
from PyQt4.QtCore import *

from qgis.core import *
from qgis.utils import iface
from qgis.gui import *
import sys
import math
import os
import string
import resources
import ntpath
import xml.etree.ElementTree as etree
from pyspatialite import dbapi2 as sqlite3
explorer = None
CRS=""



class cxf_in():
    __module__ = __name__

    def __init__(self, iface):
        self.iface = iface

    def initGui(self):
        self.pluginname = '&QGIS Importatore CXF 4.0'
        self.action = QAction(QIcon(':/plugins/Cxf_in/icon.png'), self.pluginname, self.iface.mainWindow())
        self.action.triggered.connect(self.run)
        self.iface.addToolBarIcon(self.action)
        self.iface.addPluginToMenu('&CXF import', self.action)
        for action in self.iface.pluginMenu().actions():
            if (action.text() == self.pluginname):
                action.setIcon(QIcon(':/plugins/Cxf_in/icon.png'))

    def unload(self):
        self.iface.removePluginMenu('&CXF import', self.action)
        self.iface.removeToolBarIcon(self.action)
 
    def run(self):
        dbName = os.getenv("HOME")+'/.qgis2/python/plugins/Cxf_in/catasto.sqlite'
        origini = os.getenv("HOME")+'/.qgis2/python/plugins/Cxf_in/cxfOrigini/'
        ocon = sqlite3.connect(dbName)
        ocur = ocon.cursor() 
        ocur.execute('SELECT InitSpatialMetadata()')              
        ocur.execute('VACUUM')        
        msgBox = QMessageBox()
        msgBox.setText("Attenzione")
        msgBox.setInformativeText("Nuove tabelle svuota tutto il database catastale?" )      #ret 0
        msgBox.addButton(QPushButton('Importa foglio su nuovo Database'), QMessageBox.YesRole)
        msgBox.addButton(QPushButton('Aggiungi/Sostituisci Foglio'), QMessageBox.NoRole)            #ret 1
        msgBox.addButton(QPushButton('Visualizza Fogli'), QMessageBox.NoRole)                #ret 2
        msgBox.addButton(QPushButton('Esci'), QMessageBox.RejectRole)                        #ret 3
        msgBox.setDefaultButton(QMessageBox.Cancel)
        msgBox.setIcon(QMessageBox.Question)
        ret=msgBox.exec_()
        
        if (ret == 0 or ret == 1):
        
          if os.path.exists(os.getenv("HOME")+'/workpath'):
           fpath = open(os.getenv("HOME")+'/workpath', 'r') 
           read_path = fpath.read()
           fpath.close
          else:
            read_path ="."     
          (filename, filter) = QFileDialog.getOpenFileNamesAndFilter(self.iface.mainWindow(),
                      "Seleziona un file cxf da caricare...",read_path,
                      "CXF files (*.cxf)",
                      "Filtro per selezione file")
          if len(filename)==0:
              return
      
        if (ret == 0):
          selcrs=QgsGenericProjectionSelector()
          result=selcrs.exec_()     
          if  result==1 :     
              CRS=selcrs.selectedAuthId ().split(':',1)[1]                  
          else:
              QMessageBox.information(None, "Errore :","Selezione un CRS") 
              return        
          ocur.execute('drop TABLE if exists Particelle') 
          ocur.execute('drop TABLE if exists Confine')
          ocur.execute('drop TABLE if exists Fabbricati')   
          ocur.execute('drop TABLE if exists Strade')  
          ocur.execute('drop TABLE if exists Acque')
          ocur.execute('drop TABLE if exists Linee') 
          ocur.execute('drop TABLE if exists Simboli')
          ocur.execute('drop TABLE if exists Testi')
          sql = 'Id INTEGER NOT NULL PRIMARY KEY,'
          sql += 'Codice_comune varchar(50),'        
          sql += 'Fg varchar(5),'  
          sql += 'Mappale varchar(5),'  
          sql += "'Allegato' varchar(5)," 
          sql += 'Sez varchar(5),' 
          sql += 'Nomefile varchar(11),'   
          ocur.execute('CREATE TABLE if not exists Particelle ('+sql+'Htxt real,Rtxt real,Xtxt real,Ytxt real)')    
          ocur.execute("SELECT AddGeometryColumn('Particelle','geom',"+ CRS +", 'POLYGON', 'XY')")
          #ocur.execute("select createspatialindex ('Particelle','geom')")         
          ocur.execute('CREATE TABLE if not exists Confine ('+sql+'Htxt real,Rtxt real,Xtxt real,Ytxt real)')   
          ocur.execute("SELECT AddGeometryColumn('Confine','geom',"+ CRS +", 'POLYGON', 'XY')") 
          #ocur.execute("select createspatialindex ('Confine','geom')")
          ocur.execute('CREATE TABLE if not exists Fabbricati ('+sql+'Htxt real,Rtxt real,Xtxt real,Ytxt real)')   
          ocur.execute("SELECT AddGeometryColumn('Fabbricati','geom',"+ CRS +", 'POLYGON', 'XY')")
          #ocur.execute("select createspatialindex ('Fabbricati','geom')")           
          ocur.execute('CREATE TABLE if not exists Strade ('+sql+'Htxt real,Rtxt real,Xtxt real,Ytxt real)')   
          ocur.execute("SELECT AddGeometryColumn('Strade','geom',"+ CRS +", 'POLYGON', 'XY')") 
          #ocur.execute("select createspatialindex ('Strade','geom')")          
          ocur.execute('CREATE TABLE if not exists Acque ('+sql+'Htxt real,Rtxt real,Xtxt real,Ytxt real)')   
          ocur.execute("SELECT AddGeometryColumn('Acque','geom',"+ CRS +", 'POLYGON', 'XY')")
          #ocur.execute("select createspatialindex ('Acque','geom')")
          ocur.execute('CREATE TABLE if not exists Linee ('+sql+'Cod_linea varchar(5))')   
          ocur.execute("SELECT AddGeometryColumn('Linee','geom',"+ CRS +", 'LINESTRING', 'XY')")
          #ocur.execute("select createspatialindex ('Linee','geom')")
          ocur.execute('CREATE TABLE if not exists Simboli ('+sql+'Simbolo varchar(5),Rot real)')   
          ocur.execute("SELECT AddGeometryColumn('Simboli','geom',"+ CRS +", 'POINT', 'XY')")
          #ocur.execute("select createspatialindex ('Simboli','geom')")
          ocur.execute('CREATE TABLE if not exists Testi ('+sql+'Testo varchar(50),Dim real,Rot real)')  
          ocur.execute("SELECT AddGeometryColumn('Testi','geom',"+ CRS +", 'POINT', 'XY')")
          #ocur.execute("select createspatialindex ('Testi','geom')")
          ocur.execute('CREATE TABLE if not exists Fiduciali ('+sql+'Codice varchar(50),Simbolo varchar(5),PosX real,PosY real, RelPosX real,RelPosY real)')   
          ocur.execute("SELECT AddGeometryColumn('Fiduciali','geom',"+ CRS +", 'POINT', 'XY')")
          #ocur.execute("select createspatialindex ('Fiduciali','geom')")
     
        elif (ret == 3):                     
          return
  
        
        uri = QgsDataSourceURI()
        uri.setDatabase(dbName)


        uri.setDataSource('','Particelle', 'geom')                          
        vl_part = QgsVectorLayer(uri.uri(), 'Particelle', 'spatialite')   
        uri.setDataSource('','Fabbricati', 'geom')  
        vl_ed = QgsVectorLayer(uri.uri(), 'Fabbricati', 'spatialite')
        uri.setDataSource('','Strade', 'geom')
        vl_st = QgsVectorLayer(uri.uri(), 'Strade', 'spatialite')
        uri.setDataSource('','Confine', 'geom') 
        vl_conf = QgsVectorLayer(uri.uri(), 'Confine', 'spatialite')
        uri.setDataSource('','Acque', 'geom')
        vl_aq = QgsVectorLayer(uri.uri(), 'Acque', 'spatialite')
        uri.setDataSource('','Linee', 'geom')
        vl_linee = QgsVectorLayer(uri.uri(), 'Linee', 'spatialite')
        uri.setDataSource('','Simboli', 'geom')
        vl_point = QgsVectorLayer(uri.uri(), 'Simboli', 'spatialite')
        uri.setDataSource('','Testi', 'geom')
        vl_testo = QgsVectorLayer(uri.uri(), 'Testi', 'spatialite')
        uri.setDataSource('','Fiduciali', 'geom')
        vl_fidu = QgsVectorLayer(uri.uri(), 'Fiduciali', 'spatialite')
        layers = QgsMapLayerRegistry.instance().mapLayers()      
        livlist=[]
        livcast=['Particelle' , 'Fabbricati' , 'Strade', 'Confine','Acque','Linee','Simboli','Testi','Fiduciali'] 
        for name, layid in layers.iteritems(): 
          livlist.append(layid.name())
          if layid.name() in livcast:
           QgsMapLayerRegistry.instance().removeMapLayer(name)
        mancanti=list(set(livcast) -set(livlist) )
        esistenti=set(livcast).intersection(livlist)
                  
      
        if (ret == 2 ):
            vl_part.loadNamedStyle(os.getenv("HOME")+'/.qgis2/python/plugins/Cxf_in/part.qml')
            QgsMapLayerRegistry.instance().addMapLayer(vl_part) 
            vl_ed.loadNamedStyle(os.getenv("HOME")+'/.qgis2/python/plugins/Cxf_in/fab.qml') 
            QgsMapLayerRegistry.instance().addMapLayer(vl_ed)              
            vl_st.loadNamedStyle(os.getenv("HOME")+'/.qgis2/python/plugins/Cxf_in/strade.qml')
            QgsMapLayerRegistry.instance().addMapLayer(vl_st)    
            vl_conf.loadNamedStyle(os.getenv("HOME")+'/.qgis2/python/plugins/Cxf_in/conf.qml')        
            QgsMapLayerRegistry.instance().addMapLayer(vl_conf)            
            vl_aq.loadNamedStyle(os.getenv("HOME")+'/.qgis2/python/plugins/Cxf_in/acque.qml')
            QgsMapLayerRegistry.instance().addMapLayer(vl_aq)
            vl_linee.loadNamedStyle(os.getenv("HOME")+'/.qgis2/python/plugins/Cxf_in/linee.qml')
            QgsMapLayerRegistry.instance().addMapLayer(vl_linee)          
            vl_point.loadNamedStyle(os.getenv("HOME")+'/.qgis2/python/plugins/Cxf_in/Simboli.qml')
            QgsMapLayerRegistry.instance().addMapLayer(vl_point)           
            vl_testo.loadNamedStyle(os.getenv("HOME")+'/.qgis2/python/plugins/Cxf_in/testo.qml')
            QgsMapLayerRegistry.instance().addMapLayer(vl_testo) 
            vl_fidu.loadNamedStyle(os.getenv("HOME")+'/.qgis2/python/plugins/Cxf_in/fidu.qml')
            QgsMapLayerRegistry.instance().addMapLayer(vl_fidu) 
        else:            
          QgsMapLayerRegistry.instance().reloadAllLayers()   
          fpath = open(os.getenv("HOME")+'/workpath', 'w')
          fpath.write(os.path.dirname(filename[0])) 
          fpath.close  
                
          for f in filename:
              liv=os.path.basename (os.path.splitext( str(f))[0])
              ocur.execute("SELECT distinct Nomefile from particelle where Nomefile='"+liv[0:11]+"'")  
                 
                                   
              lista=""
              conta=0
              for d in ocur:
                  conta+=1
                  lista+=d[0]
              
              
              if conta>0 :
                 #QMessageBox.information(None, "DEBUG:",lista)             
                  ocur.execute("delete from particelle where Nomefile='"+liv[0:11]+"'")  
                    
                  ocur.execute("delete from fabbricati where Nomefile='"+liv[0:11]+"'")  
                                        
                  ocur.execute("delete from Strade where Nomefile='"+liv[0:11]+"'")  
                  
                  ocur.execute("delete from Confine where Nomefile='"+liv[0:11]+"'")  
                  
                  ocur.execute("delete from Acque where Nomefile='"+liv[0:11]+"'")  
                  
                  ocur.execute("delete from Linee where Nomefile='"+liv[0:11]+"'")  
                  
                  ocur.execute("delete from Simboli where Nomefile='"+liv[0:11]+"'")  
                  
                  ocur.execute("delete from Testi where Nomefile='"+liv[0:11]+"'")  
                  
                  ocur.execute("delete from Fiduciali where Nomefile='"+liv[0:11]+"'")  
                   
                  ocur.execute("VACUUM")  
              load_cxf(str(f),liv,ocur,ocon)
        if (ret == 0):
            visualizzati= mancanti
        else:
            visualizzati= esistenti

            
        for name in visualizzati:
           if name == livcast[0]:
            vl_part.loadNamedStyle(os.getenv("HOME")+'/.qgis2/python/plugins/Cxf_in/part.qml')
            QgsMapLayerRegistry.instance().addMapLayer(vl_part)
           if name == livcast[1]:     
            vl_ed.loadNamedStyle(os.getenv("HOME")+'/.qgis2/python/plugins/Cxf_in/fab.qml') 
            QgsMapLayerRegistry.instance().addMapLayer(vl_ed)              
           if name == livcast[2]:
            vl_st.loadNamedStyle(os.getenv("HOME")+'/.qgis2/python/plugins/Cxf_in/strade.qml')
            QgsMapLayerRegistry.instance().addMapLayer(vl_st)    
           if name == livcast[3]:
            vl_conf.loadNamedStyle(os.getenv("HOME")+'/.qgis2/python/plugins/Cxf_in/conf.qml')        
            QgsMapLayerRegistry.instance().addMapLayer(vl_conf)            
           if name == livcast[4]:
            vl_aq.loadNamedStyle(os.getenv("HOME")+'/.qgis2/python/plugins/Cxf_in/acque.qml')
            QgsMapLayerRegistry.instance().addMapLayer(vl_aq)
           if name == livcast[5]:
            vl_linee.loadNamedStyle(os.getenv("HOME")+'/.qgis2/python/plugins/Cxf_in/linee.qml')
            QgsMapLayerRegistry.instance().addMapLayer(vl_linee)          
           if name == livcast[6]:
            vl_point.loadNamedStyle(os.getenv("HOME")+'/.qgis2/python/plugins/Cxf_in/Simboli.qml')
            QgsMapLayerRegistry.instance().addMapLayer(vl_point)
           if name == livcast[7]:
            vl_testo.loadNamedStyle(os.getenv("HOME")+'/.qgis2/python/plugins/Cxf_in/testo.qml')
            QgsMapLayerRegistry.instance().addMapLayer(vl_testo)                
           if name == livcast[8]:
            vl_testo.loadNamedStyle(os.getenv("HOME")+'/.qgis2/python/plugins/Cxf_in/fidu.qml')
            QgsMapLayerRegistry.instance().addMapLayer(vl_testo)  

        vl_ed.updateExtents()
        vl_st.updateExtents()
        vl_aq.updateExtents()
        vl_conf.updateExtents()
        vl_linee.updateExtents()
        vl_point.updateExtents()
        vl_testo.updateExtents()
        ocur.execute('VACUUM')
        ocon.commit()
        ocur.close() 

 
def load_cxf(filename,liv,ocur,ocon):
  try:
      in_file = open(filename,"r")
  except IOError:
      print 'Impossibile aprire il file', filename
      sys.exit()
      
  def dispoint(livello,codice ):
        geometria=[]
        simbolo= in_file.readline().strip()
        angolo= in_file.readline().strip()
        x=float(in_file.readline().strip())
        y=float(in_file.readline().strip())

        sgeometria="point ("+str(x)+" "+str(y)+")"
        sql = "INSERT INTO Simboli (Codice_comune,Fg,Mappale,Allegato,Sez,Nomefile,Simbolo,Rot,geom) VALUES  ("
        sql +="'"+ liv[0:4] + "','" + liv[5:9] + "','" + codice + "','" + liv[9:10] + "','" + liv[10:11] + "','" + liv[0:11]
        sql +="','"+simbolo+"','"+str(math.degrees(float(angolo)))+"',"          
        sql +="GeomFromText('"+ sgeometria+"'"+CRS+"))"          
        ocur.execute(sql)
                              
  def disfidu(livello,codice ):
        geometria=[]
        numero= in_file.readline().strip()
        idenum= in_file.readline().strip()
        x=float(in_file.readline().strip())
        y=float(in_file.readline().strip())
        relx=float(in_file.readline().strip())
        rely=float(in_file.readline().strip()) 

        sgeometria="point ("+str(x)+" "+str(y)+")"
        sql = "INSERT INTO Fiduciali (Codice_comune,Fg,Mappale,Allegato,Sez,Nomefile,Codice,Simbolo,PosX,PosY,RelPosX,RelPosY,geom) VALUES  ("
        sql +="'"+ liv[0:4] + "','" + liv[5:9] + "','" + codice + "','" + liv[9:10] + "','" + liv[10:11] + "','" + liv[0:11]
        sql +="','"+numero+"','"+idenum+"','"+str(float(x))+"'," +str(float(y))+"'," +str(float(relx))+"'," +str(float(rely))+"',"          
        sql +="GeomFromText('"+ sgeometria+"',"+CRS+"))"          
        ocur.execute(sql)
                 
  def distesto(livello,codice ):
        geometria=[]
        testo= in_file.readline().strip()
        dim= in_file.readline().strip()
        angolo= in_file.readline().strip()
        x=float(in_file.readline().strip())
        y=float(in_file.readline().strip()) 

        sgeometria="point ("+str(x)+" "+str(y)+")"
        sql = "INSERT INTO Testi (Codice_comune,Fg,Mappale,Allegato,Sez,Nomefile,Testo,Dim,Rot,geom) VALUES  ("
        sql +="'"+ liv[0:4] + "','" + liv[5:9] + "','" + codice + "','" + liv[9:10] + "','" + liv[10:11] + "','" + liv[0:11]
        sql +="','"+testo+"','"+str(float(dim)*float(scala)/10000)+"','"+str(math.degrees(float(angolo)))+"',"          
        sql +="GeomFromText('"+ sgeometria+"'"+CRS+"))"         
        ocur.execute(sql)
                                           
                                             
  def dislinee(livello,codice ):
        geometria=[]
        lt_testo  = in_file.readline().strip()      
        vert=int(in_file.readline().strip())
        sgeometria="Linestring ("
        for n in range (0,vert):
                  x=float(in_file.readline().strip())
                  y=float(in_file.readline().strip())    
             
                  geom= coord=[x,y]
                  if n == vert-1:
                    sgeometria=sgeometria+str(x)+" "+str(y)+")"
                  else:
                    sgeometria=sgeometria+str(x)+" "+str(y)+","                    
        sql = "INSERT INTO Linee (Codice_comune,Fg,Mappale,Allegato,Sez,Nomefile,Cod_linea,geom) VALUES  ("
        sql +="'"+ liv[0:4] + "','" + liv[5:9] + "','" + codice + "','" + liv[9:10] + "','" + liv[10:11]+ "','" + liv [0:11]
        sql +="','"+lt_testo+"',"          
        sql +="GeomFromText('"+ sgeometria+"'"+CRS+"))"  
        ocur.execute(sql)
                             

        
  def disarea(livello,codice ):
        geometria=[]
        area=[]
        lt_testo  = in_file.readline().strip()
        angolo  = in_file.readline().strip()
        x=float(in_file.readline().strip())
        y=float(in_file.readline().strip())

        orig1=[x,y]
        x=float(in_file.readline().strip())
        y=float(in_file.readline().strip())

        orig2=[x,y]
        nrisole=int(in_file.readline().strip())
        nrverttot=int(in_file.readline().strip())
        nrvertisola=[]
        for x in range(1,nrisole+1):
            nrvertisola.append(int(in_file.readline()))
        nrvertisola.insert(0,nrverttot-sum(nrvertisola))
        nrvertisola.insert(0,nrverttot-sum(nrvertisola))
        sgeometria="POLYGON"
        for isola,vert in enumerate(nrvertisola):
              sgeometria=sgeometria+"("
              for n in range (0,vert):
                  x=float(in_file.readline().strip())
                  y=float(in_file.readline().strip()) 
                  geom= coord=[x,y]
                  if n == vert-1:
                    if isola==nrisole+1:
                        sgeom=str(x)+" "+str(y)+")"
                    else:
                        sgeom=str(x)+" "+str(y)+"),"
                  else:
                    sgeom=str(x)+" "+str(y)+","
                  sgeometria=sgeometria+sgeom
                  geometria.append(coord)
              area.append(geometria)
        sgeometria=sgeometria+")"        
        

        sql = "INSERT INTO "+livello+" (Codice_comune,Fg,Mappale,Allegato,Sez,Nomefile,Htxt,Rtxt,Xtxt,Ytxt,geom) VALUES  ("
        sql +="'"+ liv[0:4] + "','" + liv[5:9] + "','" + codice + "','" + liv[9:10] + "','" + liv[10:11] + "','" + liv[0:11]
        sql +="','"+lt_testo+"','"+angolo +"','"+str(float(orig1[0])-0.1)+"','"+str(float(orig1[1])-0.25)+"',"          
        sql +="GeomFromText('"+ sgeometria+"'"+CRS+"))"    
        ocur.execute(sql)
                             
        if livello=="Particelle":    
           if (orig1[0] <>  orig2[0]) and (orig1[1] <>  orig2[1]):
              sgeometria="Linestring ("+str(orig1[0])+" "+str(orig1[1])+","+str(orig2[0])+" "+str(orig2[1])+")"      
              sql = "INSERT INTO Linee (Codice_comune,Fg,Mappale,Allegato,Sez,Nomefile,Cod_linea,geom) VALUES  ("
              sql +="'"+ liv[0:4] + "','" + liv[5:9] + "','" + codice + "','" + liv[9:10] + "','" + liv[10:11]+ "','" + liv [0:11]
              sql +="','99',"          
              sql +="GeomFromText('"+ sgeometria+"'"+CRS+"))"          
              ocur.execute(sql)
                       
  file =ntpath.split(filename)[1]

  while True:
    in_line= in_file.readline().strip()
    if in_line == "":
        break
    if in_line == 'MAPPA':
       mappa = in_file.readline().strip()
       scala=in_file.readline().strip()
    elif in_line == 'QUADRO D\'UNIONE':
       mappa = "QU"
       scala=in_file.readline().strip() 
    elif in_line == 'BORDO':
        in_line  = in_file.readline().strip()
        if in_line[len(in_line)-1] == '+':
            disarea('FABBRICATI',in_line)
        elif in_line  == 'STRADA':
            disarea('Strade',in_line)
        elif in_line  == 'ACQUA':
            disarea('Acque',in_line)
        elif in_line  == mappa:
            disarea('Confine',in_line)
        elif mappa=="QU":
            disarea('Confine',in_line)             
        elif len(in_line) == 11 :
            disarea('Sezioni',in_line)
        else:
            disarea('Particelle',in_line)
    elif in_line == "LINEA" :
            dislinee("Linee",in_line) 
    elif in_line == "SIMBOLO" :
            dispoint("Simboli",in_line) 
    elif in_line == "TESTO" :
            distesto("Testi",in_line)   
    elif in_line == "LINEA\\" :
            dislinee("Linee",in_line)
    elif in_line == "SIMBOLO\\" :
            dispoint("Simboli",in_line)
    elif in_line == "TESTO" :
            distext("Testi",in_line)
    elif in_line == "TESTO\\" :
            distesto("Testi",in_line)
    elif in_line == "FIDUCIALE" :
            dispoint("Fiduciali",in_line)
    elif in_line == "FIDUCIALE\\" :
            disfidu("Fiduciali",in_line)           
  in_file.close()




      


